package limax.auany;

import java.nio.file.Paths;
import java.util.Map;
import java.util.Optional;

import org.w3c.dom.Element;

import com.sun.net.httpserver.HttpHandler;

import limax.codec.Octets;
import limax.switcher.LmkConfigData;
import limax.switcher.LmkMasquerade;
import limax.util.ElementHelper;
import limax.util.XMLUtils;

public class LmkManager {
	private static Octets encodedLmkConfigData;
	private static LmkMasquerade lmkMasquerade;
	private static boolean validateDate;

	static void initialize(Element self, Map<String, HttpHandler> httphandlers) throws Exception {
		Optional<ElementHelper> optional = XMLUtils.getChildElements(self).stream()
				.filter(node -> node.getNodeName().equals("lmk")).map(e -> new ElementHelper(e)).findFirst();
		if (optional.isPresent()) {
			ElementHelper eh = optional.get();
			LmkConfigData lmkConfigData = new LmkConfigData(Paths.get(eh.getString("trustsPath")),
					eh.getString("revocationCheckerOptions"), validateDate = eh.getBoolean("validateDate", true));
			lmkMasquerade = lmkConfigData.createLmkMasquerade();
			encodedLmkConfigData = lmkConfigData.encode();
		}
	}

	static Octets getEncodedLmkConfigData() {
		return encodedLmkConfigData;
	}

	static LmkMasquerade getLmkMasquerade() {
		return lmkMasquerade;
	}

	static boolean hasValidateDate() {
		return validateDate;
	}
}
